package ink.wgink.common.password;

import ink.wgink.util.security.Sm3Util;
import org.apache.commons.lang3.StringUtils;
import org.springframework.security.crypto.password.PasswordEncoder;

/**
 * @ClassName: Sm3hmacPasswordEncoder
 * @Description: SM3-HMAC
 * @Author: wanggeng
 * @Date: 2022/8/16 15:43
 * @Version: 1.0
 */
public class Sm3HMacPasswordEncoder implements PasswordEncoder {

    private static String KEY = "4A2A0E14ED344656769A3B0BC4D48A59";

    @Override
    public String encode(CharSequence rawPassword) {
        return Sm3Util.encryptPlus(rawPassword.toString(), KEY);
    }

    @Override
    public boolean matches(CharSequence rawPassword, String encodedPassword) {
        return StringUtils.equals(Sm3Util.encryptPlus(rawPassword.toString(), KEY), encodedPassword);
    }

}
