package ink.wgink.common.password;

import ink.wgink.util.security.Sm4Util;
import org.apache.commons.lang3.StringUtils;
import org.springframework.security.crypto.password.PasswordEncoder;

/**
 * @ClassName: Sm4PasswordEncoder
 * @Description: SM4
 * @Author: wanggeng
 * @Date: 2022/8/16 16:01
 * @Version: 1.0
 */
public class Sm4PasswordEncoder implements PasswordEncoder {

    private static String KEY = "1F7F3097E835988D0BD61C97717BA2BC";

    @Override
    public String encode(CharSequence rawPassword) {
        return Sm4Util.encryptEcb(KEY, rawPassword.toString());
    }

    @Override
    public boolean matches(CharSequence rawPassword, String encodedPassword) {
        return StringUtils.equals(Sm4Util.encryptEcb(KEY, rawPassword.toString()), encodedPassword);
    }


}
