package ink.wgink.module.attn.dao.attnconfig;

import ink.wgink.exceptions.RemoveException;
import ink.wgink.exceptions.SaveException;
import ink.wgink.exceptions.SearchException;
import ink.wgink.module.attn.pojo.dtos.attnconfig.AttnConfigDTO;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IAttnConfigDao
 * @Description: 考勤配置
 * @Author: CodeFactory
 * @Date: 2022-07-11 15:13:00
 * @Version: 3.0
 **/
@Repository
public interface IAttnConfigDao {

    /**
     * 新增考勤配置
     *
     * @param params
     * @throws SaveException
     */
    void save(Map<String, Object> params) throws SaveException;

    /**
     * 删除考勤配置（物理）
     *
     * @param params
     * @throws RemoveException
     */
    void delete() throws RemoveException;

    /**
     * 考勤配置详情
     *
     * @param configKey
     * @return
     * @throws SearchException
     */
    AttnConfigDTO get(String configKey) throws SearchException;

    /**
     * 考勤配置列表
     *
     * @return
     * @throws SearchException
     */
    List<AttnConfigDTO> list() throws SearchException;

    /**
     * 考勤配置统计
     *
     * @param params
     * @return
     * @throws SearchException
     */
    Integer count(Map<String, Object> params) throws SearchException;

}