package ink.wgink.module.attn.dao.signout;

import ink.wgink.exceptions.RemoveException;
import ink.wgink.exceptions.SaveException;
import ink.wgink.exceptions.SearchException;
import ink.wgink.exceptions.UpdateException;
import ink.wgink.module.attn.pojo.bos.signout.SignOutBO;
import ink.wgink.module.attn.pojo.dtos.signout.SignOutDTO;
import ink.wgink.module.attn.pojo.pos.signout.SignOutPO;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: ISignOutDao
 * @Description: 考勤签退
 * @Author: CodeFactory
 * @Date: 2022-07-11 15:09:12
 * @Version: 3.0
 **/
@Repository
public interface ISignOutDao {

    /**
     * 新增考勤签退
     *
     * @param params
     * @throws SaveException
     */
    void save(Map<String, Object> params) throws SaveException;

    /**
     * 删除考勤签退
     *
     * @param params
     * @throws RemoveException
     */
    void remove(Map<String, Object> params) throws RemoveException;

    /**
     * 删除考勤签退（物理）
     *
     * @param params
     * @throws RemoveException
     */
    void delete(Map<String, Object> params) throws RemoveException;

    /**
     * 修改考勤签退
     *
     * @param params
     * @throws UpdateException
     */
    void update(Map<String, Object> params) throws UpdateException;

    /**
     * 考勤签退详情
     *
     * @param params
     * @return
     * @throws SearchException
     */
    SignOutDTO get(Map<String, Object> params) throws SearchException;

    /**
     * 考勤签退详情
     *
     * @param params
     * @return
     * @throws SearchException
     */
    SignOutBO getBO(Map<String, Object> params) throws SearchException;

    /**
     * 考勤签退详情
     *
     * @param params
     * @return
     * @throws SearchException
     */
    SignOutPO getPO(Map<String, Object> params) throws SearchException;

    /**
     * 考勤签退列表
     *
     * @param params
     * @return
     * @throws SearchException
     */
    List<SignOutDTO> list(Map<String, Object> params) throws SearchException;

    /**
     * 考勤签退列表
     *
     * @param params
     * @return
     * @throws SearchException
     */
    List<SignOutBO> listBO(Map<String, Object> params) throws SearchException;

    /**
     * 考勤签退列表
     *
     * @param params
     * @return
     * @throws SearchException
     */
    List<SignOutPO> listPO(Map<String, Object> params) throws SearchException;

    /**
     * 考勤签退统计
     *
     * @param params
     * @return
     * @throws SearchException
     */
    Integer count(Map<String, Object> params) throws SearchException;

}