package ink.wgink.module.attn.manager;

import ink.wgink.module.attn.dao.attnconfig.IAttnConfigDao;
import ink.wgink.module.attn.pojo.dtos.attnconfig.AttnConfigDTO;
import org.ehcache.impl.internal.concurrent.ConcurrentHashMap;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IAttnConfigManager
 * @Description: 考勤配置管理
 * @Author: wanggeng
 * @Date: 2022/7/12 10:31
 * @Version: 1.0
 */
public class AttnConfigManager {

    private static final AttnConfigManager manager = AttnConfigManagerBuilder.attnConfigManager;
    private IAttnConfigDao attnConfigDao;
    private Map<String, String> configMap = new ConcurrentHashMap<>();

    private AttnConfigManager() {

    }

    public static AttnConfigManager getInstance() {
        return manager;
    }

    /**
     * 刷新配置
     */
    public void refresh() {
        attnConfigDao.delete();
        List<AttnConfigDTO> attnConfigDTOS = attnConfigDao.list();
        configMap.clear();
        attnConfigDTOS.forEach(attnConfigDTO -> {
            configMap.put(attnConfigDTO.getConfigKey(), attnConfigDTO.getConfigValue());
        });
    }

    /**
     * 获取值
     *
     * @param key
     * @return
     */
    public String getValue(String key) {
        return configMap.get(key);
    }

    public void setAttnConfigDao(IAttnConfigDao attnConfigDao) {
        this.attnConfigDao = attnConfigDao;
    }

    private static class AttnConfigManagerBuilder {
        public static AttnConfigManager attnConfigManager = new AttnConfigManager();
    }

}
