package ink.wgink.module.attn.service.signin;

import ink.wgink.module.attn.pojo.bos.signin.SignInBO;
import ink.wgink.module.attn.pojo.dtos.signin.SignInDTO;
import ink.wgink.module.attn.pojo.pos.signin.SignInPO;
import ink.wgink.module.attn.pojo.vos.signin.SignInVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: ISignInService
 * @Description: 考勤签到
 * @Author: CodeFactory
 * @Date: 2022-07-11 15:08:18
 * @Version: 3.0
 **/
public interface ISignInService {

    /**
     * 新增考勤签到
     *
     * @param signInVO
     * @return
     */
    void save(SignInVO signInVO);

    /**
     * 新增考勤签到
     *
     * @param token
     * @param signInVO
     * @return
     */
    void save(String token, SignInVO signInVO);

    /**
     * 新增考勤签到
     *
     * @param signInVO
     * @return signInId
     */
    String saveReturnId(SignInVO signInVO);

    /**
     * 新增考勤签到
     *
     * @param token
     * @param signInVO
     * @return signInId
     */
    String saveReturnId(String token, SignInVO signInVO);

    /**
     * 删除考勤签到
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除考勤签到
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除考勤签到（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改考勤签到
     *
     * @param signInId
     * @param signInVO
     * @return
     */
    void update(String signInId, SignInVO signInVO);

    /**
     * 修改考勤签到
     *
     * @param token
     * @param signInId
     * @param signInVO
     * @return
     */
    void update(String token, String signInId, SignInVO signInVO);

    /**
     * 考勤签到详情
     *
     * @param params 参数Map
     * @return
     */
    SignInDTO get(Map<String, Object> params);

    /**
     * 考勤签到详情
     *
     * @param signInId
     * @return
     */
    SignInDTO get(String signInId);

    /**
     * 考勤签到详情
     *
     * @param params 参数Map
     * @return
     */
    SignInBO getBO(Map<String, Object> params);

    /**
     * 考勤签到详情
     *
     * @param signInId
     * @return
     */
    SignInBO getBO(String signInId);

    /**
     * 考勤签到详情
     *
     * @param params 参数Map
     * @return
     */
    SignInPO getPO(Map<String, Object> params);

    /**
     * 考勤签到详情
     *
     * @param signInId
     * @return
     */
    SignInPO getPO(String signInId);

    /**
     * 考勤签到列表
     *
     * @param params
     * @return
     */
    List<SignInDTO> list(Map<String, Object> params);

    /**
     * 考勤签到列表
     *
     * @param params
     * @return
     */
    List<SignInBO> listBO(Map<String, Object> params);

    /**
     * 考勤签到列表
     *
     * @param params
     * @return
     */
    List<SignInPO> listPO(Map<String, Object> params);

    /**
     * 考勤签到分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<SignInDTO>> listPage(ListPage page);

    /**
     * 考勤签到统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

}