package ink.wgink.module.attn.service.signout;

import ink.wgink.module.attn.pojo.bos.signout.SignOutBO;
import ink.wgink.module.attn.pojo.dtos.signout.SignOutDTO;
import ink.wgink.module.attn.pojo.pos.signout.SignOutPO;
import ink.wgink.module.attn.pojo.vos.signout.SignOutVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: ISignOutService
 * @Description: 考勤签退
 * @Author: CodeFactory
 * @Date: 2022-07-11 15:09:12
 * @Version: 3.0
 **/
public interface ISignOutService {

    /**
     * 新增考勤签退
     *
     * @param signOutVO
     * @return
     */
    void save(SignOutVO signOutVO);

    /**
     * 新增考勤签退
     *
     * @param token
     * @param signOutVO
     * @return
     */
    void save(String token, SignOutVO signOutVO);

    /**
     * 新增考勤签退
     *
     * @param signOutVO
     * @return signOutId
     */
    String saveReturnId(SignOutVO signOutVO);

    /**
     * 新增考勤签退
     *
     * @param token
     * @param signOutVO
     * @return signOutId
     */
    String saveReturnId(String token, SignOutVO signOutVO);

    /**
     * 删除考勤签退
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除考勤签退
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除考勤签退（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改考勤签退
     *
     * @param signOutId
     * @param signOutVO
     * @return
     */
    void update(String signOutId, SignOutVO signOutVO);

    /**
     * 修改考勤签退
     *
     * @param token
     * @param signOutId
     * @param signOutVO
     * @return
     */
    void update(String token, String signOutId, SignOutVO signOutVO);

    /**
     * 考勤签退详情
     *
     * @param params 参数Map
     * @return
     */
    SignOutDTO get(Map<String, Object> params);

    /**
     * 考勤签退详情
     *
     * @param signOutId
     * @return
     */
    SignOutDTO get(String signOutId);

    /**
     * 考勤签退详情
     *
     * @param params 参数Map
     * @return
     */
    SignOutBO getBO(Map<String, Object> params);

    /**
     * 考勤签退详情
     *
     * @param signOutId
     * @return
     */
    SignOutBO getBO(String signOutId);

    /**
     * 考勤签退详情
     *
     * @param params 参数Map
     * @return
     */
    SignOutPO getPO(Map<String, Object> params);

    /**
     * 考勤签退详情
     *
     * @param signOutId
     * @return
     */
    SignOutPO getPO(String signOutId);

    /**
     * 考勤签退列表
     *
     * @param params
     * @return
     */
    List<SignOutDTO> list(Map<String, Object> params);

    /**
     * 考勤签退列表
     *
     * @param params
     * @return
     */
    List<SignOutBO> listBO(Map<String, Object> params);

    /**
     * 考勤签退列表
     *
     * @param params
     * @return
     */
    List<SignOutPO> listPO(Map<String, Object> params);

    /**
     * 考勤签退分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<SignOutDTO>> listPage(ListPage page);

    /**
     * 考勤签退统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

}