package ink.wgink.service.core.controller.route.manage;

import ink.wgink.interfaces.consts.ISystemConstant;
import ink.wgink.interfaces.user.IUserExpandBaseService;
import ink.wgink.interfaces.user.IUserExpandOptionButton;
import ink.wgink.service.user.util.UserUtil;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

/**
 * @ClassName: CoreManageRouteController
 * @Description: 核心管理
 * @Author: wanggeng
 * @Date: 2022/8/10 16:29
 * @Version: 1.0
 */
@Api(tags = ISystemConstant.ROUTE_TAGS_PREFIX + "核心管理路由")
@Controller
@RequestMapping(ISystemConstant.ROUTE_PREFIX + "/core/manage")
public class CoreManageRouteController {

    @Autowired(required = false)
    private IUserExpandBaseService userExpandBaseService;
    @Autowired(required = false)
    private IUserExpandOptionButton userExpandOptionButton;

    @GetMapping("list-department-tree")
    public ModelAndView listDepartmentTree() {
        ModelAndView modelAndView = new ModelAndView("core/manage/list-department-tree");
        return modelAndView;
    }

    @GetMapping("list-department-user")
    public ModelAndView listDepartmentUser() {
        ModelAndView modelAndView = new ModelAndView("core/manage/list-department-user");
        UserUtil.setUserListPageExpand(userExpandBaseService, userExpandOptionButton, modelAndView);
        return modelAndView;
    }

    @GetMapping("list-department-user-select")
    public ModelAndView listDepartmentUserSelect() {
        ModelAndView modelAndView = new ModelAndView("core/manage/list-department-user-select");
        return modelAndView;
    }

    @GetMapping("save-department-user")
    public ModelAndView saveDepartmentUser() {
        ModelAndView modelAndView = new ModelAndView("core/manage/save-department-user");
        return modelAndView;
    }

    @GetMapping("update-department-user")
    public ModelAndView updateDepartmentUser() {
        ModelAndView modelAndView = new ModelAndView("core/manage/update-department-user");
        return modelAndView;
    }

}
