package ink.wgink.service.core.init.build;

import ink.wgink.interfaces.init.build.IBuildServiceMenu;
import ink.wgink.pojo.bos.menu.InitMenuBO;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @ClassName: BuildCoreManageMenu
 * @Description: 构建核心菜单
 * @Author: wanggeng
 * @Date: 2022/8/17 16:04
 * @Version: 1.0
 */
@Component
public class BuildCoreManageMenu implements IBuildServiceMenu {

    @Override
    public void buildMenu(List<InitMenuBO> initMenus) {
        // 获取用户管理
        InitMenuBO parentMenu = initMenus.get(1);
        // 获取子菜单
        List<InitMenuBO> subMenus = parentMenu.getSubMenus();
        InitMenuBO initMenu = new InitMenuBO();
        initMenu.setMenuName("综合管理");
        initMenu.setMenuSummary("综合管理");
        initMenu.setMenuUrl("/route/core/manage/list-department-tree");
        initMenu.setMenuIcon("fa-icon-color-white fa fa-address-book");
        subMenus.add(initMenu);
        // 更新子菜单
        parentMenu.setSubMenus(subMenus);
    }

}
