package ink.wgink.service.core.service.manage;

import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.dtos.department.DepartmentDTO;
import ink.wgink.pojo.dtos.user.UserDTO;
import ink.wgink.pojo.result.SuccessResultList;
import ink.wgink.service.core.pojo.vos.manage.CoreManageUserVO;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: ICoreManageService
 * @Description: 核心管理
 * @Author: wanggeng
 * @Date: 2022/8/10 16:28
 * @Version: 1.0
 */
public interface ICoreManageService {

    /**
     * 保存用户
     *
     * @param coreManageUserVO
     */
    void saveUser(CoreManageUserVO coreManageUserVO);

    /**
     * 删除用户
     *
     * @param userIds
     */
    void removeUser(List<String> userIds);

    /**
     * 修改用户
     *
     * @param userId
     * @param coreManageUserVO
     */
    void updateUser(String userId, CoreManageUserVO coreManageUserVO);


    /**
     * 用户详情
     *
     * @param userId
     * @return
     */
    UserDTO getUser(String userId);

    /**
     * 组织部门导航列表
     *
     * @param departmentId
     * @return
     */
    List<DepartmentDTO> listDepartmentNavPathByDepartmentId(String departmentId);

    /**
     * 用户列表
     *
     * @return
     */
    List<UserDTO> listUser(Map<String, Object> params);

    /**
     * 用户列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<UserDTO>> listPageUser(ListPage page);

}
