/**
 * 关闭窗口
 */
function closeBox() {
    parent.layer.close(parent.layer.getFrameIndex(window.name));
}

/**
 * 初始化下拉树
 * @param $
 * @param layuiInputTree
 */
function initMultiSelectInputTree($, layuiInputTree) {
    /**
     * 设置选择数据
     * @param ids
     * @param names
     */
    function setSelectedData(selectedDatas, ids, names) {
        if (!ids) {
            return;
        }
        ids = ids.split(',');
        names = names.split(',');
        $.each(ids, function (index, item) {
            selectedDatas.push({
                id: item,
                name: names[index]
            })
        })
    }

    // 组织部门选择
    function initDepartmentSelect() {
        layuiInputTree.initMultiSelect({
            id: 'departmentNames',
            url: 'api/department/listztree',
            checkboxType: {Y: '', N: ''},
            getSelectedDatas: function () {
                var selectedDepartments = []
                setSelectedData(selectedDepartments, $('#departmentIds').val(), $('#departmentNames').val());
                return selectedDepartments;
            },
            onConfirm: function (zTree, selectedNodes) {
                if (selectedNodes.length == 0) {
                    $('#departmentIds').val('');
                    return;
                }
                var departmentIds = '';
                $.each(selectedNodes, function (index, item) {
                    if (departmentIds != '') {
                        departmentIds += ',';
                    }
                    departmentIds += item.id;
                })
                $('#departmentIds').val(departmentIds);
            }
        })
    }

    // 角色选择
    function initRoleSelect() {
        layuiInputTree.initMultiSelect({
            id: 'roleNames',
            url: 'api/role/listztree',
            checkboxType: {Y: '', N: ''},
            getSelectedDatas: function () {
                var selectedRoles = [];
                setSelectedData(selectedRoles, $('#roleIds').val(), $('#roleNames').val());
                return selectedRoles;
            },
            onConfirm: function (zTree, selectedNodes) {
                if (selectedNodes.length == 0) {
                    $('#roleIds').val('');
                    return;
                }
                var roleIds = '';
                $.each(selectedNodes, function (index, item) {
                    if (roleIds != '') {
                        roleIds += ',';
                    }
                    roleIds += item.id;
                })
                $('#roleIds').val(roleIds);
            }
        })
    }

    // 职位选择
    function initPositionSelect() {
        layuiInputTree.initMultiSelect({
            id: 'positionNames',
            url: 'api/position/listztree',
            checkboxType: {Y: '', N: ''},
            getSelectedDatas: function () {
                var selectedPositions = [];
                setSelectedData(selectedPositions, $('#positionIds').val(), $('#positionNames').val());
                return selectedPositions;
            },
            onConfirm: function (zTree, selectedNodes) {
                if (selectedNodes.length == 0) {
                    $('#positionIds').val('');
                    return;
                }
                var positionIds = '';
                $.each(selectedNodes, function (index, item) {
                    if (positionIds != '') {
                        positionIds += ',';
                    }
                    positionIds += item.id;
                })
                $('#positionIds').val(positionIds);
            }
        })
    }

    // 组选择
    function initGroupSelect() {
        layuiInputTree.initMultiSelect({
            id: 'groupNames',
            url: 'api/group/listztree',
            checkboxType: {Y: '', N: ''},
            getSelectedDatas: function () {
                var selectedGroups = [];
                setSelectedData(selectedGroups, $('#groupIds').val(), $('#groupNames').val());
                return selectedGroups;
            },
            onConfirm: function (zTree, selectedNodes) {
                if (selectedNodes.length == 0) {
                    $('#groupIds').val('');
                    return;
                }
                var groupIds = '';
                $.each(selectedNodes, function (index, item) {
                    if (groupIds != '') {
                        groupIds += ',';
                    }
                    groupIds += item.id;
                })
                $('#groupIds').val(groupIds);
            }
        })
    }

    initDepartmentSelect();
    initRoleSelect();
    initPositionSelect();
    initGroupSelect();
}

/**
 *
 * @param laydate
 */
function initDate(laydate) {
    laydate.render({
        elem: '#userExpiredDate',
        trigger: 'click',
        format: 'yyyy-MM-dd HH:mm:ss'
    });
}

/**
 * 设置ID列表
 * @param $
 * @param formDataField
 */
function setIds($, formDataField) {
    var departmentIds = $('#departmentIds').val();
    if (departmentIds) {
        departmentIds = departmentIds.split(',');
    } else {
        departmentIds = [];
    }
    var roleIds = $('#roleIds').val();
    if (roleIds) {
        roleIds = roleIds.split(',');
    } else {
        roleIds = [];
    }
    var positionIds = $('#positionIds').val();
    if (positionIds) {
        positionIds = positionIds.split(',');
    } else {
        positionIds = [];
    }
    var groupIds = $('#groupIds').val();
    if (groupIds) {
        groupIds = groupIds.split(',');
    } else {
        groupIds = [];
    }
    formDataField.departmentIds = departmentIds;
    formDataField.roleIds = roleIds;
    formDataField.positionIds = positionIds;
    formDataField.groupIds = groupIds;
}